// Copyright (c) 2015, Mikhail Stolyarov. All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

library do2init.observable;

import 'do2observer.dart';

abstract class Do2Observable{

    List<Do2Observer> _listenControllers = new List();

    void attach(Do2Observer observer){
        _listenControllers.add(observer);
    }

    void detach(Do2Observer observer){
        _listenControllers.remove(observer);
    }

    void notify(){
        _listenControllers.forEach((Do2Observer observer)=>observer.update(this));
    }

}